/******************************************************************************** 
Desarrollado por:   Globant de México
Autor:              Roberto Carlos Avendaño Quintana
Proyecto:           TOYOTA TAM
Descripción:        Clase que contiene la logica para el funcionamiento de la clase de prueba estado de cuenta (INCENTIVOS)
******************************************************************************* */
@isTest
public class EstadoCuentaController_Test {
    
    @testSetup static void setup() {
        User thisUser = [SELECT Id FROM User WHERE Id = '0051Y000009UruJQAS'];
        //Se obtiene el recordtype del distribuidor
        String recordIdDistribuidor  = Schema.SObjectType.Account.getRecordTypeInfosByDeveloperName().get('Dealer').getRecordTypeId();
        
        //Se inserta una cuenta de tipo Disitribuidor
        Account a01 = new Account(
            Name = 'Dealer',
            Codigo_Distribuidor__c = '57002',
            recordTypeId = recordIdDistribuidor
        );
        insert a01;
        
        //Se insera un contacto del distribuidor
        Contact contactRH1 = new Contact();
        contactRH1.NombreUsuario__c = 'Contacto RH1';
        contactRH1.lastName = 'Contacto RH1';
        contactRH1.Email = 'test@test.com';
        contactRH1.AccountId = a01.id;
        insert contactRH1;
        
        //Se ejecuta el insert del nuevo usuario como usuario administrador
        system.runAs(thisUser){  
            //Obtenemos el rol de la instancia 
            UserRole uR = [SELECT Id FROM UserRole WHERE Name='Toyota Dalton Industrias Socio Ejecutivo'];
            //Obtenemos un perfil RH de muestra de la instancia
            Profile p = [SELECT Id FROM Profile WHERE Name='Gerente de Ventas Distribuidor']; 
            
            //Se crea un usuario de SFDC relacionado a el contacto usado en la licencia
            User u = new User(Alias = 'standt', Email='standarduser@testorg.com', 
                              EmailEncodingKey='UTF-8', LastName='Testing1', LanguageLocaleKey='en_US', 
                              LocaleSidKey='en_US',ContactId = contactRH1.id,ProfileId = p.Id,PortalRole  = 'Manager',
                              TimeZoneSidKey='America/Los_Angeles', UserName='test99@testorg.com');
            system.debug('usuario'+u);
            insert u;
            
            //Obtenemos un perfil RH de muestra de la instancia
            Profile auditor = [SELECT Id FROM Profile WHERE Name='Auditor Finanzas Platform']; 
            
            User auditorUser = new User(Alias = 'standt1', Email='auditor@auditor.com', 
                                        EmailEncodingKey='UTF-8', LastName='Testing1', LanguageLocaleKey='en_US', 
                                        LocaleSidKey='en_US',ProfileId = auditor.Id,PortalRole  = 'Manager',
                                        TimeZoneSidKey='America/Los_Angeles', UserName='Auditor@testorg.com');
            system.debug('usuario'+auditorUser);
            insert auditorUser;
            
            //Perfil de dealer
            Profile dealer = [SELECT Id FROM Profile WHERE Name='Usuario de DTM']; 
            
            User dealerUser = new User(Alias = 'dealer', Email='dealer@dealer.com', 
                                       EmailEncodingKey='UTF-8', LastName='Testing1', LanguageLocaleKey='en_US', 
                                       LocaleSidKey='en_US',ProfileId = dealer.Id,PortalRole  = 'Manager',
                                       TimeZoneSidKey='America/Los_Angeles', UserName='dealer@testorg.com');
            system.debug('usuario'+dealerUser);
            insert dealerUser;
            
        }
        
        //VIN de prueba 1
        Vehiculo__c v01 = new Vehiculo__c(
            Name='12345678901234567',
            Id_Externo__c='12345678901234567'
        );
        insert v01;
        
        //Se inserta la serie del VIN
        Serie__c ser01 = new Serie__c(
            Id_Externo_Serie__c = 'X',
            Name = 'X'
        );
        insert ser01;
        
        //Se inserta el modelo del VIN
        Modelo__c modelo01 = new Modelo__c(
            Serie__c = ser01.Id,
            ID_Modelo__c = 'Y'
        );
        insert modelo01;
        
        //Se inserta un movimiento relacionado al VIN
        Movimiento__c m01 = new Movimiento__c(
            Distribuidor__c = a01.Id,
            Submitted_Date__c = Datetime.now(),
            Sale_Date__c = date.today(),
            VIN__c = v01.Id,
            Id_Modelo__c = modelo01.Id,
            Trans_Type__c = 'RDR',
            Sale_Code__c = '04',
            Fleet__c = 'C',
            First_Name__c = 'Héctor'
        ); 
        insert m01;
        
        //VIN de prueba 2
        Vehiculo__c v02 = new Vehiculo__c(
            Name='45678901234QUERY',
            Id_Externo__c='45678901234QUERY'
        );
        insert v02;
        
        
        //Factura del VIN
        Factura__c factTest = new Factura__c();
        factTest.VIN__c = v01.id;
        factTest.TAM_Folio__c = 'A0012020';
        factTest.TAM_NombreReceptor__c  = 'Hector Figueroa';
        facttest.Distribuidor__c = a01.id;
        facttest.TAM_IdDealerCode__c               = '57002';
        insert factTest;
        
        //Solicitud de Excepción
        String recordIdSolicitudRetail = Schema.SObjectType.TAM_SolicitudExpecionIncentivo__c.getRecordTypeInfosByDeveloperName().get('Cambio_de_Incentivo').getRecordTypeId();
        TAM_SolicitudExpecionIncentivo__c solExcepcion = new TAM_SolicitudExpecionIncentivo__c();
        solExcepcion.RecordTypeId = recordIdSolicitudRetail;
        solExcepcion.TAMVIN__c	 = 'JTDKARFU2L3122771';
        solExcepcion.TAM_AprobacionDM__c = 'Aprobado';
        solExcepcion.TAM_AprobacionFinanzas__c = 'Aprobado';
        solExcepcion.TAM_ComentarioDM__c = 'Comenatario de test';
        solExcepcion.TAM_ComentarioFinanzas__c = 'De Test';
        solExcepcion.TAM_Comentario__c = 'De Test';
        solExcepcion.TAM_Distribuidor__c  =   a01.id;
        solExcepcion.TAM_Email_DM__c = 'test@test.com';
        solExcepcion.TAM_EstadoCuenta__c = false;
        solExcepcion.TAM_Fecha_Autorizacion_DM__c = date.today()-1;
        solExcepcion.TAM_Fecha_Autorizacion_Finanzas__c = date.today();
        solExcepcion.TAM_MotivoSolicitud__c = 'El cliente adquirió el auto con las promociones del mes pasado, pero solicita que se le apliquen las vigentes.';
        solExcepcion.TAM_TipoVenta__c = 'Con TFS';
        insert solExcepcion;
        
        
        
        //Provisión de incentivos
        TAM_ProvisionIncentivos__c provTest01 = new TAM_ProvisionIncentivos__c();
        provTest01.name = 'Provisión Agosto de prueba';
        provTest01.TAM_AnioDeProvision__c = '2020';
        provTest01.TAM_MesDeProvision__c = 'Agosto';
        insert provTest01;
        
        //Detalle de Provisión
        String recordIdProvisionRetail  = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByDeveloperName().get('Retail').getRecordTypeId();
        //Retail
        TAM_DetalleProvisionIncentivo__c detalleProv01 = new TAM_DetalleProvisionIncentivo__c();
        detalleProv01.name = 'MR0EX3DD1L0005455-HILUX-7495-2020-a26e00000013ycLAAQ-Bono Lealtad Hilux Prius';
        detalleProv01.RecordTypeId = recordIdProvisionRetail;
        detalleProv01.RetailSinReversa_Cerrado__c = false;
        detalleProv01.TAM_AnioModelo__c = '2020';
        detalleProv01.TAM_AplicanAmbos__c = false;
        detalleProv01.TAM_Clasificacion__c = 'Sin Reversa';
        detalleProv01.TAM_CodigoContable__c = '7400B2';
        detalleProv01.TAM_CodigoDealer__c = '57002';
        detalleProv01.TAM_Factura__c = 'FVA12330';
        detalleProv01.TAM_FechaCierre__c = date.today();
        detalleProv01.TAM_FechaEnvio__c = '2020-06-18 15:39:44';
        detalleProv01.TAM_FechaVenta__c = '2020-06-17';
        detalleProv01.TAM_FirstName__c = 'DORA LUZ';
        detalleProv01.TAM_IncentivoTMEX_Efectivo__c = 	5040.0;
        detalleProv01.TAM_IncentivoTMEX_PF__c = 0;
        detalleProv01.TAM_LastName__c = 'VAZQUEZ PEREZ';
        detalleProv01.TAM_Lealtad__c = false;
        detalleProv01.TAM_Modelo__c = '7495';
        detalleProv01.TAM_NombreDealer__c = 'TOYOTA TEST';
        detalleProv01.TAM_PagadoConTFS__c = false;
        detalleProv01.TAM_PagadoSinTFS__c = true;
        detalleProv01.TAM_ProvicionarEfectivo__c = true;
        detalleProv01.TAM_Provisionado__c = false;
        detalleProv01.TAM_ProvisionarBonoEfectivo__c = false;
        detalleProv01.TAM_ProvisionarBonoFinanciero__c = false;
        detalleProv01.TAM_ProvisionarLealtad__c = false;
        detalleProv01.TAM_ProvisionCerrada__c = true;
        detalleProv01.TAM_Serie__c	 = 'HILUX';
        detalleProv01.TAM_SolicitadoDealer__c = false;
        detalleProv01.TAM_TipoMovimiento__c = 'RDR';
        detalleProv01.TAM_TMEXEfectivoMenor__c = 5040; 
        detalleProv01.TAM_TransmitirDealer__c = true;
        detalleProv01.TAM_VIN__c  =  v01.id;
        detalleProv01.TAM_ProvisionIncentivos__c =  provTest01.id;
        insert detalleProv01;
        
        
        //Detalle Provisión 02
        TAM_DetalleProvisionIncentivo__c detalleProv02 = new TAM_DetalleProvisionIncentivo__c();
        detalleProv02.name = 'HILUX-7495-2020-a26e00000013ycLAAQ-Bono Lealtad Hilux Prius TEST';
        detalleProv02.RecordTypeId = recordIdProvisionRetail;
        detalleProv02.RetailSinReversa_Cerrado__c = false;
        detalleProv02.TAM_AnioModelo__c = '2020';
        detalleProv02.TAM_AplicanAmbos__c = false;
        detalleProv02.TAM_Clasificacion__c = 'Sin Reversa';
        detalleProv02.TAM_CodigoContable__c = '7400B2';
        detalleProv02.TAM_CodigoDealer__c = '57002';
        detalleProv02.TAM_Factura__c = 'FVA12330';
        detalleProv02.TAM_FechaCierre__c = date.today();
        detalleProv02.TAM_FechaEnvio__c = '2020-06-18 15:39:44';
        detalleProv02.TAM_FechaVenta__c = '2020-06-17';
        detalleProv02.TAM_FirstName__c = 'DORA LUZ';
        detalleProv02.TAM_IncentivoTMEX_Efectivo__c = 	5040.0;
        detalleProv02.TAM_IncentivoTMEX_PF__c = 0;
        detalleProv02.TAM_LastName__c = 'VAZQUEZ PEREZ';
        detalleProv02.TAM_Lealtad__c = false;
        detalleProv02.TAM_Modelo__c = '7495';
        detalleProv02.TAM_NombreDealer__c = 'TOYOTA TEST';
        detalleProv02.TAM_PagadoConTFS__c = false;
        detalleProv02.TAM_PagadoSinTFS__c = true;
        detalleProv02.TAM_ProvicionarEfectivo__c = true;
        detalleProv02.TAM_Provisionado__c = false;
        detalleProv02.TAM_ProvisionarBonoEfectivo__c = false;
        detalleProv02.TAM_ProvisionarBonoFinanciero__c = false;
        detalleProv02.TAM_ProvisionarLealtad__c = false;
        detalleProv02.TAM_ProvisionCerrada__c = true;
        detalleProv02.TAM_Serie__c	 = 'HILUX';
        detalleProv02.TAM_SolicitadoDealer__c = false;
        detalleProv02.TAM_TipoMovimiento__c = 'RDR';
        detalleProv02.TAM_TMEXEfectivoMenor__c = 5040; 
        detalleProv02.TAM_TransmitirDealer__c = true;
        detalleProv02.TAM_VIN__c  =  v02.id;
        detalleProv02.TAM_ProvisionIncentivos__c =  provTest01.id;
        insert detalleProv02;
        
        //Politica de Incentivos   
        TAM_PoliticasIncentivos__c politicaRetail = new TAM_PoliticasIncentivos__c();
        politicaRetail.Name = 'Politica Test';
        politicaRetail.TAM_InicioVigencia__c = Date.today()-210;
        politicaRetail.TAM_FinVigencia__c = Date.today() + 230;
        politicaRetail.TAM_PeriodoDeGracia__c = 5;
        politicaRetail.TAM_EstatusIncentivos__c = 'Vigente';
        politicaRetail.TAM_CargaHistorica__c = true;
        politicaRetail.RecordTypeId = Schema.SObjectType.TAM_PoliticasIncentivos__c.getRecordTypeInfosByName().get('Retail').getRecordTypeId();
        system.debug('fecha inicio'+politicaRetail.TAM_InicioVigencia__c);
        insert  politicaRetail;
        
        //Detalle de la politica
        TAM_DetallePoliticaJunction__c detallePolitica = new TAM_DetallePoliticaJunction__c();
        detallePolitica.TAM_AnioModelo__c = '2020';
        detallePolitica.TAM_BonoLealtad__c = 5000;
        detallePolitica.TAM_BonoLealtadDealer__c = 2500;
        detallePolitica.TAM_BonoLealtadTMEX__c = 2500;
        detallePolitica.TAM_Descripcion__c = 'Test';
        detallePolitica.Name = 'Detalle de prueba';
        detallePolitica.TAM_IncPropuesto_Cash__c = 10000;
        detallePolitica.TAM_IncDealer_Cash__c = 5000;
        detallePolitica.TAM_IncentivoTMEX_Cash__c = 5000;
        detallePolitica.TAM_Lealtad__c  = true;
        detallePolitica.TAM_PoliticaIncentivos__c = politicaRetail.id;
        detallePolitica.TAM_Serie__c = 'Corolla';
        detallePolitica.TAM_Clave__c = '1780';
        detallePolitica.TAM_Pago_TFS__c = true;
        insert detallePolitica;
        
        //Se crea un estado de cuenta de prueba
        TAM_EstadoCuenta__c edoCta = new TAM_EstadoCuenta__c();
        edoCta.name = 'JULIO-TEST';
        edoCta.TAM_EstadoRegistro__c = 'Abierto';
        edoCta.TAM_CodigoDealer__c = '57002';
        edoCta.TAM_NombreDealer__c  = 'TOYOTA DE PRUEBA';
        edoCta.TAM_FechaInicio__c = date.today();
        edoCta.TAM_FechaCierre__c = date.today()+90;
        insert edoCta;
        
        //lineas del estado de cuenta retail
        String recordIdedoCtaRetail  = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Retail').getRecordTypeId();
        TAM_DetalleEstadoCuenta__c detalleEdoCta = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCta.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCta.RecordTypeId = recordIdedoCtaRetail;
        detalleEdoCta.TAM_ApellidosPropietario__c = 'Figueroas';
        detalleEdoCta.TAM_AnioModelo__c = '2020';
        detalleEdoCta.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCta.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCta.TAM_CodigoDealer__c = '57002';
        detalleEdoCta.TAM_Codigo_Producto__c = '7400';
        detalleEdoCta.TAM_DetalleProvision__c = detalleProv01.id;
        detalleEdoCta.TAM_EnviadoFacturar__c = false;
        detalleEdoCta.TAM_EdoCtaCerrado__c = false;
        detalleEdoCta.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCta.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCta.TAM_VINEntregado__c = true;
        detalleEdoCta.TAM_VIN__c = '12345678901234567';
        detalleEdoCta.TAM_pagoPorTFS__c = false;
        detalleEdoCta.TAM_Serie__c = 'HILUX';
        detalleEdoCta.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCta.TAM_EstatusVINEdoCta__c = 'Enviado a Facturar';
        detalleEdoCta.TAM_SolicitudExcepcion__c = solExcepcion.id;
        detalleEdoCta.TAM_Estatus_Finanzas__c = 'Pendiente';
        insert detalleEdoCta;
        
        //Retail 02 con una provisión
        TAM_DetalleEstadoCuenta__c detalleEdoCtaRetail02 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaRetail02.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaRetail02.RecordTypeId = recordIdedoCtaRetail;
        detalleEdoCtaRetail02.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaRetail02.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaRetail02.TAM_AnioModelo__c = '2020';
        detalleEdoCtaRetail02.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaRetail02.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaRetail02.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaRetail02.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaRetail02.TAM_DetalleProvision__c = detalleProv01.id;
        detalleEdoCtaRetail02.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaRetail02.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaRetail02.TAM_EstatusVINEdoCta__c = 'Pendiente de cobro';
        detalleEdoCtaRetail02.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaRetail02.TAM_VINEntregado__c = true;
        detalleEdoCtaRetail02.TAM_VIN__c = '12345678901234567';
        detalleEdoCtaRetail02.TAM_pagoPorTFS__c = false;
        detalleEdoCtaRetail02.TAM_Serie__c = 'HILUX';
        detalleEdoCtaRetail02.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaRetail02.TAM_SolicitudExcepcion__c = solExcepcion.id;
        detalleEdoCtaRetail02.TAM_Estatus_Finanzas__c = 'Pendiente';
        insert detalleEdoCtaRetail02;       
        
        //Retail 03 SIN una provisión
        TAM_DetalleEstadoCuenta__c detalleEdoCtaRetail03 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaRetail03.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaRetail03.RecordTypeId = recordIdedoCtaRetail;
        detalleEdoCtaRetail03.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaRetail03.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaRetail03.TAM_AnioModelo__c = '2020';
        detalleEdoCtaRetail03.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaRetail03.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaRetail03.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaRetail03.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaRetail03.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaRetail03.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaRetail03.TAM_EstatusVINEdoCta__c = 'Pendiente de cobro';
        detalleEdoCtaRetail03.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaRetail03.TAM_VINEntregado__c = true;
        detalleEdoCtaRetail03.TAM_VIN__c = '12345678901234567';
        detalleEdoCtaRetail03.TAM_pagoPorTFS__c = false;
        detalleEdoCtaRetail03.TAM_Serie__c = 'HILUX';
        detalleEdoCtaRetail03.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaRetail03.TAM_SolicitudExcepcion__c = solExcepcion.id;
        detalleEdoCtaRetail03.TAM_Estatus_Finanzas__c = 'Pago Autorizado TMEX';
        insert detalleEdoCtaRetail03;       
        
        //Retail 04 SIN una provisión
        TAM_DetalleEstadoCuenta__c detalleEdoCtaRetail04 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaRetail04.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaRetail04.RecordTypeId = recordIdedoCtaRetail;
        detalleEdoCtaRetail04.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaRetail04.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaRetail04.TAM_AnioModelo__c = '2020';
        detalleEdoCtaRetail04.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaRetail04.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaRetail04.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaRetail04.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaRetail04.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaRetail04.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaRetail04.TAM_EstatusVINEdoCta__c = 'Pendiente de cobro';
        detalleEdoCtaRetail04.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaRetail04.TAM_VINEntregado__c = true;
        detalleEdoCtaRetail04.TAM_VIN__c = '1234567890123QUERY';
        detalleEdoCtaRetail04.TAM_pagoPorTFS__c = false;
        detalleEdoCtaRetail04.TAM_Serie__c = 'HILUX';
        detalleEdoCtaRetail04.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaRetail04.TAM_SolicitudExcepcion__c = solExcepcion.id;
        detalleEdoCtaRetail04.TAM_Estatus_Finanzas__c = 'Pago Autorizado TMEX';
        insert detalleEdoCtaRetail04;   
        
        //Retail 05 sin factura y con provisión
        TAM_DetalleEstadoCuenta__c detalleEdoCtaRetail05 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaRetail05.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaRetail05.RecordTypeId = recordIdedoCtaRetail;
        detalleEdoCtaRetail05.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaRetail05.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaRetail05.TAM_AnioModelo__c = '2020';
        detalleEdoCtaRetail05.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaRetail05.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaRetail05.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaRetail05.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaRetail05.TAM_DetalleProvision__c = detalleProv02.id;
        detalleEdoCtaRetail05.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaRetail05.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaRetail05.TAM_EstatusVINEdoCta__c = 'Pendiente de cobro';
        detalleEdoCtaRetail05.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaRetail05.TAM_VINEntregado__c = true;
        detalleEdoCtaRetail05.TAM_VIN__c = '45678901234QUERY';
        detalleEdoCtaRetail05.TAM_pagoPorTFS__c = false;
        detalleEdoCtaRetail05.TAM_Serie__c = 'HILUX';
        detalleEdoCtaRetail05.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaRetail05.TAM_SolicitudExcepcion__c = solExcepcion.id;
        detalleEdoCtaRetail05.TAM_Estatus_Finanzas__c = 'Rechazado por Finanzas';
        insert detalleEdoCtaRetail05;   
        
        //TEST PARA VENTA CORPORATIVA lineas del estado de cuenta VC con provisión
        String recordIdedoCtaVC = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Flotilla').getRecordTypeId();
        TAM_DetalleEstadoCuenta__c detalleEdoCtaVC = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaVC.TAM_IncentivoPropuestoDealer__c = 25000;
        detalleEdoCtaVC.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaVC.RecordTypeId = recordIdedoCtaVC;
        detalleEdoCtaVC.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaVC.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaVC.TAM_AnioModelo__c = '2020';
        detalleEdoCtaVC.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaVC.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaVC.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaVC.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaVC.TAM_DetalleProvision__c = detalleProv01.id;
        detalleEdoCtaVC.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaVC.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaVC.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaVC.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaVC.TAM_VINEntregado__c = true;
        detalleEdoCtaVC.TAM_VIN__c = '12345678901234567';
        detalleEdoCtaVC.TAM_pagoPorTFS__c = false;
        detalleEdoCtaVC.TAM_Serie__c = 'HILUX';
        detalleEdoCtaVC.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaVC.TAM_SolicitudExcepcion__c = solExcepcion.id;
        detalleEdoCtaVC.TAM_Estatus_Finanzas__c = 'Pago Cancelado Finanzas';
        insert detalleEdoCtaVC;
        
        //lineas del estado de cuenta VC sin provisión
        TAM_DetalleEstadoCuenta__c detalleEdoCtaVC02 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaVC02.TAM_IncentivoPropuestoDealer__c = 25000;
        detalleEdoCtaVC02.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaVC02.RecordTypeId = recordIdedoCtaVC;
        detalleEdoCtaVC02.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaVC02.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaVC02.TAM_AnioModelo__c = '2020';
        detalleEdoCtaVC02.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaVC02.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaVC02.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaVC02.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaVC02.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaVC02.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaVC02.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaVC02.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaVC02.TAM_VINEntregado__c = true;
        detalleEdoCtaVC02.TAM_VIN__c = '12345678901234567';
        detalleEdoCtaVC02.TAM_pagoPorTFS__c = false;
        detalleEdoCtaVC02.TAM_Serie__c = 'HILUX';
        detalleEdoCtaVC02.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaVC02.TAM_Movimiento__c = 'Excepción';
        detalleEdoCtaVC02.TAM_Porcentaje__c = 5;
        detalleEdoCtaVC02.TAM_Programa_Rango__c = 'UBER';
        detalleEdoCtaVC02.TAM_SolicitudExcepcion__c = solExcepcion.id;
        insert detalleEdoCtaVC02;
        
        //lineas del estado de cuenta VC sin provisión y sin factura
        TAM_DetalleEstadoCuenta__c detalleEdoCtaVC03 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaVC03.TAM_IncentivoPropuestoDealer__c = 25000;
        detalleEdoCtaVC03.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaVC03.RecordTypeId = recordIdedoCtaVC;
        detalleEdoCtaVC03.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaVC03.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaVC03.TAM_AnioModelo__c = '2020';
        detalleEdoCtaVC03.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaVC03.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaVC03.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaVC03.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaVC03.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaVC03.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaVC03.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaVC03.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaVC03.TAM_VINEntregado__c = true;
        detalleEdoCtaVC03.TAM_VIN__c = 'QUERY5678901234567';
        detalleEdoCtaVC03.TAM_pagoPorTFS__c = false;
        detalleEdoCtaVC03.TAM_Serie__c = 'HILUX';
        detalleEdoCtaVC03.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaVC03.TAM_Movimiento__c = 'VIN Agregado';
        detalleEdoCtaVC03.TAM_Programa_Rango__c = 'UBER';
        detalleEdoCtaVC03.TAM_Porcentaje__c = 5;
        detalleEdoCtaVC03.TAM_Porcentaje_TMEX__c = 5;
        detalleEdoCtaVC03.TAM_Monto_sin_IVA__c = 15000;
        detalleEdoCtaVC03.TAM_SolicitudExcepcion__c = solExcepcion.id;
        insert detalleEdoCtaVC03;
        
        //lineas del estado de cuenta VC sin provisión y sin factura
        TAM_DetalleEstadoCuenta__c detalleEdoCtaVC04 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaVC04.TAM_IncentivoPropuestoDealer__c = 25000;
        detalleEdoCtaVC04.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaVC04.RecordTypeId = recordIdedoCtaVC;
        detalleEdoCtaVC04.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaVC04.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaVC04.TAM_AnioModelo__c = '2020';
        detalleEdoCtaVC04.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaVC04.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaVC04.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaVC04.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaVC04.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaVC04.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaVC04.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaVC04.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaVC04.TAM_VINEntregado__c = true;
        detalleEdoCtaVC04.TAM_VIN__c = 'QUEAY5678901234567';
        detalleEdoCtaVC04.TAM_pagoPorTFS__c = false;
        detalleEdoCtaVC04.TAM_Serie__c = 'HILUX';
        detalleEdoCtaVC04.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaVC04.TAM_Movimiento__c = 'Excepción';
        detalleEdoCtaVC04.TAM_Programa_Rango__c = 'UBER';
        detalleEdoCtaVC04.TAM_Porcentaje__c = 5;
        detalleEdoCtaVC04.TAM_Porcentaje_TMEX__c = 5;
        detalleEdoCtaVC04.TAM_Monto_sin_IVA__c = 15000;
        detalleEdoCtaVC04.TAM_SolicitudExcepcion__c = solExcepcion.id;
        insert detalleEdoCtaVC04;
        
        //lineas del estado de cuenta VC con provisión y sin factura
        TAM_DetalleEstadoCuenta__c detalleEdoCtaVC05 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaVC05.TAM_IncentivoPropuestoDealer__c = 25000;
        detalleEdoCtaVC05.TAM_Monto_sin_IVA__c = 25000;
        detalleEdoCtaVC05.RecordTypeId = recordIdedoCtaVC;
        detalleEdoCtaVC05.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaVC05.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaVC05.TAM_AnioModelo__c = '2020';
        detalleEdoCtaVC05.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaVC05.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaVC05.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaVC05.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaVC05.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaVC05.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaVC05.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaVC05.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaVC05.TAM_DetalleProvision__c = detalleProv01.id;
        detalleEdoCtaVC05.TAM_VINEntregado__c = true;
        detalleEdoCtaVC05.TAM_VIN__c = 'QUEAY5678901234567';
        detalleEdoCtaVC05.TAM_pagoPorTFS__c = false;
        detalleEdoCtaVC05.TAM_Serie__c = 'HILUX';
        detalleEdoCtaVC05.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaVC05.TAM_Movimiento__c = 'Excepción';
        detalleEdoCtaVC05.TAM_Programa_Rango__c = 'UBER';
        detalleEdoCtaVC05.TAM_Porcentaje__c = 5;
        detalleEdoCtaVC05.TAM_Porcentaje_TMEX__c = 5;
        detalleEdoCtaVC05.TAM_Monto_sin_IVA__c = 15000;
        detalleEdoCtaVC05.TAM_SolicitudExcepcion__c = solExcepcion.id;
        insert detalleEdoCtaVC05;
        
        //Se inserta el custom Setting de días de vigencia
        TAM_DetalleEdoCta__c customSetting1 = new TAM_DetalleEdoCta__c();
        customSetting1.TAM_DiasVigencia__c = 97;
        insert customSetting1;
        
        //Se crea la factura relacionada
        Factura__c factVIN  = new Factura__c();
        factVIN.VIN__c = v01.Id;
        factVIN.AnioModelo__c = 2020;
        factVIN.Distribuidor__c = a01.Id;
        factVIN.Name = 'TEST FACTURA';
        factVIN.TAM_FechaTimbrado__c = date.today();
        factVIN.TAM_Folio__c = 'TESTA001';
        factVIN.TAM_Importe__c = 25000;
        insert factVIN;
        
        //Solicitud de AutoDemo
        TAM_SolicitudAutoDemo__c solAutoDemo = new  TAM_SolicitudAutoDemo__c();
        solAutoDemo.TAM_AnioModelo__c = '2020';
        solAutoDemo.TAM_CodigoDistribuidor__c = '57605';
        solAutoDemo.TAM_CodigoVenta__c = '06';
        solAutoDemo.TAM_CostoTMEXSinIVA__c = 5172.413793103448;
        solAutoDemo.TAM_EdoCuenta__c =  false;
        solAutoDemo.TAM_FechaVenta__c = date.today();
        solAutoDemo.TAM_IncentivoDealerDefinido__c = 6000.0;
        solAutoDemo.TAM_IncentivoDefinidoPoliticas__c = 12000.0;
        solAutoDemo.TAM_IncentivoOtorgado__c = -92462.0;
        solAutoDemo.TAM_IncentivoTMEXDefinido__c = 6000;
        solAutoDemo.TAM_Modelo__c = '7497';
        solAutoDemo.TAM_NombreDistribuidor__c = 'TOYOTA TEST';
        solAutoDemo.TAM_ParticipacionTMEX__c = 50;
        solAutoDemo.TAM_PrecioLista__c = 266900.0;
        solAutoDemo.TAM_PrecioMenosIncentivo__c = 254900.0; 
        solAutoDemo.TAM_Serie__c = 'HILUX';
        solAutoDemo.TAM_ValorFactura__c = 359362.0;
        solAutoDemo.TAM_VIN__c = v01.id;
        solAutoDemo.TAM_Movimiento__c = m01.id;
        solAutoDemo.TAM_ReembolsoInteres__c = 2000;
        solAutoDemo.TAM_Factura__c = factVIN.id;
        insert solAutoDemo;
        
        
        //Data de modulo de Autos Demo con provisión y factura 
        String recordIdedoCtaAutoDemo = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('AutoDemo').getRecordTypeId();
        TAM_DetalleEstadoCuenta__c detalleEdoCtarecordIdedoCtaAutoDemo = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtarecordIdedoCtaAutoDemo.RecordTypeId = recordIdedoCtaAutoDemo;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_SolicitudAutoDemo__c = solAutoDemo.id;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_AnioModelo__c = '2020';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_CodigoDealer__c = '57011';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_DetalleProvision__c = detalleProv01.id;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_EnviadoFacturar__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_VINEntregado__c = true;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_VIN__c = '12345678901234567';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_pagoPorTFS__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_Serie__c = 'HILUX';
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_IncentivoPropuestoDealer__c = 4032.78;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_Monto_sin_IVA__c = 3230.32;
        insert detalleEdoCtarecordIdedoCtaAutoDemo;
        
        //Data de modulo de Autos Demo con provisión y sin factura 
        TAM_DetalleEstadoCuenta__c detalleEdoCtarecordIdedoCtaAutoDemo02 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtarecordIdedoCtaAutoDemo02.RecordTypeId = recordIdedoCtaAutoDemo;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_SolicitudAutoDemo__c = solAutoDemo.id;
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_AnioModelo__c = '2020';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_CodigoDealer__c = '57011';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_DetalleProvision__c = detalleProv02.id;
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_EnviadoFacturar__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_VINEntregado__c = true;
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_VIN__c = '45678901234QUERY';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_pagoPorTFS__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_Serie__c = 'HILUX';
        detalleEdoCtarecordIdedoCtaAutoDemo02.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_IncentivoPropuestoDealer__c = 4032.55;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_Monto_sin_IVA__c = 3230.32;
        insert detalleEdoCtarecordIdedoCtaAutoDemo02;
        
        //Data de modulo de Autos Demo sin provisión y con factura 
        TAM_DetalleEstadoCuenta__c detalleEdoCtarecordIdedoCtaAutoDemo03 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtarecordIdedoCtaAutoDemo03.RecordTypeId = recordIdedoCtaAutoDemo;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_SolicitudAutoDemo__c = solAutoDemo.id;
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_AnioModelo__c = '2020';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_CodigoDealer__c = '57011';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_EnviadoFacturar__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_VINEntregado__c = true;
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_VIN__c = '12345678901234567';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_pagoPorTFS__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_Serie__c = 'HILUX';
        detalleEdoCtarecordIdedoCtaAutoDemo03.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_IncentivoPropuestoDealer__c = 4032.43;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_Monto_sin_IVA__c = 3230.32;
        insert detalleEdoCtarecordIdedoCtaAutoDemo03;
        
        //Data de modulo de Autos Demo sin provisión y sin factura 
        TAM_DetalleEstadoCuenta__c detalleEdoCtarecordIdedoCtaAutoDemo05 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtarecordIdedoCtaAutoDemo05.RecordTypeId = recordIdedoCtaAutoDemo;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_SolicitudAutoDemo__c = solAutoDemo.id;
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_AnioModelo__c = '2020';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_CodigoDealer__c = '57011';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_EnviadoFacturar__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_VINEntregado__c = true;
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_VIN__c = 'QUEAY5678901234567';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_pagoPorTFS__c = false;
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_Serie__c = 'HILUX';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_Movimiento__c = 'Excepción';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_Programa_Rango__c = 'UBER';
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_Porcentaje__c = 5;
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_Porcentaje_TMEX__c = 5;
        detalleEdoCtarecordIdedoCtaAutoDemo05.TAM_Monto_sin_IVA__c = 15000.13;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_IncentivoPropuestoDealer__c = 4032.12;
        detalleEdoCtarecordIdedoCtaAutoDemo.TAM_Monto_sin_IVA__c = 3230.32;
        insert detalleEdoCtarecordIdedoCtaAutoDemo05;
        
        //Datos de prueba para Bono con provisión y con factura
        String recordIdedoCtaBono = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByDeveloperName().get('Bono').getRecordTypeId();
        TAM_DetalleEstadoCuenta__c detalleEdoCtaBono = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaBono.RecordTypeId = recordIdedoCtaBono;
        detalleEdoCtaBono.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaBono.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaBono.TAM_AnioModelo__c = '2020';
        detalleEdoCtaBono.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaBono.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaBono.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaBono.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaBono.TAM_DetalleProvision__c = detalleProv01.id;
        detalleEdoCtaBono.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaBono.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaBono.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaBono.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaBono.TAM_VINEntregado__c = true;
        detalleEdoCtaBono.TAM_VIN__c = '12345678901234567';
        detalleEdoCtaBono.TAM_pagoPorTFS__c = false;
        detalleEdoCtaBono.TAM_Serie__c = 'HILUX';
        detalleEdoCtaBono.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaBono.TAM_IncentivoPropuestoDealer__c = 3492.342;
        insert detalleEdoCtaBono;
        
        //Datos de prueba para Bono con provisión y sin factura
        TAM_DetalleEstadoCuenta__c detalleEdoCtaBono01 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaBono01.RecordTypeId = recordIdedoCtaBono;
        detalleEdoCtaBono01.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaBono01.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaBono01.TAM_AnioModelo__c = '2020';
        detalleEdoCtaBono01.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaBono01.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaBono01.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaBono01.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaBono01.TAM_DetalleProvision__c = detalleProv02.id;
        detalleEdoCtaBono01.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaBono01.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaBono01.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaBono01.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaBono01.TAM_VINEntregado__c = true;
        detalleEdoCtaBono01.TAM_VIN__c = '45678901234QUERY';
        detalleEdoCtaBono01.TAM_pagoPorTFS__c = false;
        detalleEdoCtaBono01.TAM_Serie__c = 'HILUX';
        detalleEdoCtaBono01.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaBono01.TAM_IncentivoPropuestoDealer__c = 3492.342;
        insert detalleEdoCtaBono01;
        
        //Datos de prueba para Bono sin provisión y con factura
        TAM_DetalleEstadoCuenta__c detalleEdoCtaBono02 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaBono02.RecordTypeId = recordIdedoCtaBono;
        detalleEdoCtaBono02.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaBono02.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaBono02.TAM_AnioModelo__c = '2020';
        detalleEdoCtaBono02.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaBono02.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaBono02.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaBono02.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaBono02.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaBono02.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaBono02.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaBono02.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaBono02.TAM_VINEntregado__c = true;
        detalleEdoCtaBono02.TAM_VIN__c = '12345678901234567';
        detalleEdoCtaBono02.TAM_pagoPorTFS__c = false;
        detalleEdoCtaBono02.TAM_Serie__c = 'HILUX';
        detalleEdoCtaBono02.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaBono02.TAM_IncentivoPropuestoDealer__c = 3492.342;
        insert detalleEdoCtaBono02;
        
        //Datos de prueba para Bono sin provisión y sin factura
        TAM_DetalleEstadoCuenta__c detalleEdoCtaBono03 = new TAM_DetalleEstadoCuenta__c();
        detalleEdoCtaBono03.RecordTypeId = recordIdedoCtaBono;
        detalleEdoCtaBono03.TAM_ApellidosPropietario__c = 'Figueroa';
        detalleEdoCtaBono03.TAM_ApellidosPropietario__c = '2020';
        detalleEdoCtaBono03.TAM_AnioModelo__c = '2020';
        detalleEdoCtaBono03.TAM_ComentarioDealer__c = 'Metodo de prueba';
        detalleEdoCtaBono03.TAM_Comentario_Finanzas__c = 'Metodo de prueba';
        detalleEdoCtaBono03.TAM_CodigoDealer__c = '57011';
        detalleEdoCtaBono03.TAM_Codigo_Producto__c = '7400';
        detalleEdoCtaBono03.TAM_EnviadoFacturar__c = false;
        detalleEdoCtaBono03.TAM_EdoCtaCerrado__c = false;
        detalleEdoCtaBono03.TAM_EstatusVINEdoCta__c = 'Revisado y listo para cobro';
        detalleEdoCtaBono03.TAM_EstatusVINProvision__c = 'Autorizado para Pago';
        detalleEdoCtaBono03.TAM_VINEntregado__c = true;
        detalleEdoCtaBono03.TAM_VIN__c = 'RC345678901234567';
        detalleEdoCtaBono03.TAM_pagoPorTFS__c = false;
        detalleEdoCtaBono03.TAM_Serie__c = 'HILUX';
        detalleEdoCtaBono03.TAM_EstadoCuenta__c = edoCta.id;
        detalleEdoCtaBono03.TAM_IncentivoPropuestoDealer__c = 3492.342;
        insert detalleEdoCtaBono03;
        
    }
    
    //Test del metodo getCurrentUser
    @isTest static void testMethod1(){
        User usr = [select id from User Where email = 'standarduser@testorg.com'];
        EstadoCuentaController.getCurrentUser(usr.id);
        
    }
    
    //Test del metodo getInfoGralEdoCta
    @isTest static void testMethod2(){
        TAM_EstadoCuenta__c edoCta = [select id from TAM_EstadoCuenta__c Where name = 'JULIO-TEST'];
        EstadoCuentaController.getInfoGralEdoCta(edoCta.id);
        
    }
    
    //Test del metodo getProvisionByDealer Retail
    @isTest static void testMethod3(){
        TAM_EstadoCuenta__c edoCta = [select id from TAM_EstadoCuenta__c Where name = 'JULIO-TEST'];
        Test.startTest();
        //Finanzas PorCobrar
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'PorCobrar','Retail','0051Y000009UruJQAS');
        //Auditor PorCobrar
        User auditor = [Select id From User where email = 'auditor@auditor.com'];
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'PorCobrar','Retail',auditor.id);
        //Dealer PorCobrar             
        User dealer = [Select id From User where email = 'dealer@dealer.com'];
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'PorCobrar','Retail',dealer.id);   
        
        //Finanzas noCobrados
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'noCobrados','Retail','0051Y000009UruJQAS');
        //Auditor noCobrados
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'noCobrados','Retail',auditor.id);
        //Dealer PorCobrar             
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'noCobrados','Retail',dealer.id); 
        
        //Finanzas enviadosFacturar
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'enviadosFacturar','Retail','0051Y000009UruJQAS');
        //Auditor enviadosFacturar
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'enviadosFacturar','Retail',auditor.id);
        //Dealer enviadosFacturar             
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'enviadosFacturar','Retail',dealer.id); 
        
        Test.stopTest();
    }
    
    
    //Test del metodo getProvisionByDealer Ventas Corporativa
    @isTest static void testMethod4(){
        TAM_EstadoCuenta__c edoCta = [select id from TAM_EstadoCuenta__c Where name = 'JULIO-TEST'];
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'PorCobrar','VentaCorporativa','0051Y000009UruJQAS');
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'noCobrados','VentaCorporativa','0051Y000009UruJQAS');
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'enviadosFacturar','VentaCorporativa','0051Y000009UruJQAS');
        
    }
    
    //Test del metodo getProvisionByDealer Ventas Auto Demo
    @isTest static void testMethod5(){
        TAM_EstadoCuenta__c edoCta = [select id from TAM_EstadoCuenta__c Where name = 'JULIO-TEST'];
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'PorCobrar','AutoDemo','0051Y000009UruJQAS');
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'noCobrados','AutoDemo','0051Y000009UruJQAS');
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'enviadosFacturar','AutoDemo','0051Y000009UruJQAS');
        
    }
    
    //Test del metodo getProvisionByDealer Ventas Auto Demo
    @isTest static void testMethod6(){
        TAM_EstadoCuenta__c edoCta = [select id from TAM_EstadoCuenta__c Where name = 'JULIO-TEST'];    
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'PorCobrar','Bono','0051Y000009UruJQAS');
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'noCobrados','Bono','0051Y000009UruJQAS');
        EstadoCuentaController.getProvisionByDealer(edoCta.id,'enviadosFacturar','Bono','0051Y000009UruJQAS');
        
    }
    
    //Test del metodo savePointEdoCta
    @isTest static void testMethod7(){
        //Se obtiene el id de la política
        TAM_DetallePoliticaJunction__c detallePolitica = [Select id from TAM_DetallePoliticaJunction__c WHERE name = 'Detalle de prueba' limit 1];
        EstadoCuentaController.wrapperEstadoCta wrrapperItem = new EstadoCuentaController.wrapperEstadoCta();
        wrrapperItem.VIN = 'QWERTYAKDKAQP20';
        wrrapperItem.Id  = '01029101';
        wrrapperItem.apellidoPropietario = 'Figueroa';
        wrrapperItem.anioModelo = '2020';
        wrrapperItem.codigoDealer = '57011';
        wrrapperItem.comentarioDealer = 'Todo ok';
        wrrapperItem.EdoCtaCerrado = false;
        wrrapperItem.estatusVINEdoCta = 'Autorizado de cobro';
        wrrapperItem.facturaVenta  =  'Test001';
        wrrapperItem.nombreDealer  ='TOYOTA GUADALAJARA';
        wrrapperItem.nombrePropietario = 'Hector';
        wrrapperItem.IdDetalleProvision = 'Test';
        wrrapperItem.IdDetalleEdoCta = 'Estado cuenta';
        wrrapperItem.IdEstadoCuenta = 'EstadoCuenta';
        wrrapperItem.serie  = 'Corolla';
        wrrapperItem.codigoModelo = '5462';    
        wrrapperItem.incentivoProvisionadoDealer = 12391;
        wrrapperItem.incentivoSolicitadoDealer = 12391;
        wrrapperItem.nombreProvision = 'Provision de prueba';
        wrrapperItem.idProvision = 'AQDNJHED56474';
        wrrapperItem.idFacturaVenta = 'FACTURA2010';
        wrrapperItem.VINEntregado = true;
        wrrapperItem.fechaVenta = '2021-06-05';
        wrrapperItem.incentivorEfectivoTotal = 2233;
        wrrapperItem.tipoTransaction = 'RDR';
        wrrapperItem.validarTransferencia = false;
        wrrapperItem.idPoliticaIncentivo = detallePolitica.id;
        
        //Se ejecuta el metodo savePointEdoCta
        EstadoCuentaController.savePointEdoCta(wrrapperItem);
        
        //Se ejecuta el metodo compararIncentivos
        EstadoCuentaController.compararIncentivos(wrrapperItem);
        
        //Se ejecuta el metodo getIncentivoCorrespondiente
        EstadoCuentaController.getIncentivoCorrespondiente(wrrapperItem);
    }
    
    //Test del metodo saveEdoCta
    @isTest static void testMethod8(){
        List<EstadoCuentaController.wrapperEstadoCta> lisEdoCta = new List<EstadoCuentaController.wrapperEstadoCta>();
        TAM_EstadoCuenta__c estadoCuenta = [select id from TAM_EstadoCuenta__c where name = 'JULIO-TEST'];
        TAM_DetalleEstadoCuenta__c detalleEdoCta = [Select id from TAM_DetalleEstadoCuenta__c WHERE TAM_VIN__C =: '12345678901234567' limit 1];
        EstadoCuentaController.wrapperEstadoCta wrrapperItem = new EstadoCuentaController.wrapperEstadoCta();
        wrrapperItem.VIN = 'QWERTYAKDKAQP20';
        wrrapperItem.Id  = detalleEdoCta.id;
        wrrapperItem.apellidoPropietario = 'Figueroa';
        wrrapperItem.anioModelo = '2020';
        wrrapperItem.codigoDealer = '57011';
        wrrapperItem.comentarioDealer = 'Todo ok';
        wrrapperItem.EdoCtaCerrado = false;
        wrrapperItem.estatusVINEdoCta = 'Autorizado de cobro';
        wrrapperItem.facturaVenta  =  'Test001';
        wrrapperItem.nombreDealer  ='TOYOTA GUADALAJARA';
        wrrapperItem.nombrePropietario = 'Hector';
        wrrapperItem.IdDetalleProvision = 'Test';
        wrrapperItem.IdDetalleEdoCta = 'Estado cuenta';
        wrrapperItem.IdEstadoCuenta = 'EstadoCuenta';
        wrrapperItem.serie  = 'Corolla';
        wrrapperItem.codigoModelo = '5462';    
        wrrapperItem.incentivoProvisionadoDealer = 12391;
        wrrapperItem.incentivoSolicitadoDealer = 12391;
        wrrapperItem.nombreProvision = 'Provision de prueba';
        wrrapperItem.idProvision = 'AQDNJHED56474';
        wrrapperItem.idFacturaVenta = 'FACTURA2010';
        wrrapperItem.VINEntregado = true;
        wrrapperItem.IdEstadoCuenta = estadoCuenta.id;
        wrrapperItem.validarTransferencia = false;
        lisEdoCta.add(wrrapperItem);
        
        EstadoCuentaController.wrapperEstadoCta wrrapperItem02 = new EstadoCuentaController.wrapperEstadoCta();
        wrrapperItem02.VIN = 'QWERTYAKDKAQP20';
        wrrapperItem02.Id  = detalleEdoCta.id;
        wrrapperItem02.apellidoPropietario = 'Figueroa';
        wrrapperItem02.anioModelo = '2020';
        wrrapperItem02.codigoDealer = '57011';
        wrrapperItem02.comentarioDealer = 'Todo ok';
        wrrapperItem02.EdoCtaCerrado = false;
        wrrapperItem02.estatusVINEdoCta = 'Autorizado de cobro';
        wrrapperItem02.facturaVenta  =  'Test001';
        wrrapperItem02.nombreDealer  ='TOYOTA GUADALAJARA';
        wrrapperItem02.nombrePropietario = 'Hector';
        wrrapperItem02.IdDetalleProvision = 'Test';
        wrrapperItem02.IdDetalleEdoCta = 'Estado cuenta';
        wrrapperItem02.IdEstadoCuenta = 'EstadoCuenta';
        wrrapperItem02.serie  = 'Corolla';
        wrrapperItem02.codigoModelo = '5462';    
        wrrapperItem02.incentivoProvisionadoDealer = 12391;
        wrrapperItem02.incentivoSolicitadoDealer = 12391;
        wrrapperItem02.nombreProvision = 'Provision de prueba';
        wrrapperItem02.idProvision = 'AQDNJHED56474';
        wrrapperItem02.idFacturaVenta = 'FACTURA2010';
        wrrapperItem02.VINEntregado = true;
        wrrapperItem02.IdEstadoCuenta = estadoCuenta.id;
        wrrapperItem02.validarTransferencia = true;
        lisEdoCta.add(wrrapperItem02);
        
        EstadoCuentaController.wrapperEstadoCta wrrapperItem03 = new EstadoCuentaController.wrapperEstadoCta();
        wrrapperItem03.VIN = 'QWERTYAKDKAQP20';
        wrrapperItem03.Id  = detalleEdoCta.id;
        wrrapperItem03.apellidoPropietario = 'Figueroa';
        wrrapperItem03.anioModelo = '2020';
        wrrapperItem03.codigoDealer = '57011';
        wrrapperItem03.comentarioDealer = 'Todo ok';
        wrrapperItem03.EdoCtaCerrado = false;
        wrrapperItem03.estatusVINEdoCta = 'Revisado y listo para cobro';
        wrrapperItem03.facturaVenta  =  'Test001';
        wrrapperItem03.nombreDealer  ='TOYOTA GUADALAJARA';
        wrrapperItem03.nombrePropietario = 'Hector';
        wrrapperItem03.IdDetalleProvision = 'Test';
        wrrapperItem03.IdDetalleEdoCta = 'Estado cuenta';
        wrrapperItem03.IdEstadoCuenta = 'EstadoCuenta';
        wrrapperItem03.serie  = 'Corolla';
        wrrapperItem03.codigoModelo = '5462';    
        wrrapperItem03.incentivoProvisionadoDealer = 12391;
        wrrapperItem03.incentivoSolicitadoDealer = 12391;
        wrrapperItem03.nombreProvision = 'Provision de prueba';
        wrrapperItem03.idProvision = 'AQDNJHED56474';
        wrrapperItem03.idFacturaVenta = 'FACTURA2010';
        wrrapperItem03.VINEntregado = true;
        wrrapperItem03.IdEstadoCuenta = estadoCuenta.id;
        wrrapperItem03.validarTransferencia = false;
        lisEdoCta.add(wrrapperItem03);
        
        EstadoCuentaController.wrapperEstadoCta wrrapperItem04 = new EstadoCuentaController.wrapperEstadoCta();
        wrrapperItem04.VIN = 'QWERTYAKDKAQP20';
        wrrapperItem04.Id  = detalleEdoCta.id;
        wrrapperItem04.apellidoPropietario = 'Figueroa';
        wrrapperItem04.anioModelo = '2020';
        wrrapperItem04.codigoDealer = '57011';
        wrrapperItem04.comentarioDealer = 'Todo ok';
        wrrapperItem04.EdoCtaCerrado = false;
        wrrapperItem04.estatusFinanzasTMEX = 'Rechazado por Finanzas';
        wrrapperItem04.facturaVenta  =  'Test001';
        wrrapperItem04.nombreDealer  ='TOYOTA GUADALAJARA';
        wrrapperItem04.nombrePropietario = 'Hector';
        wrrapperItem04.IdDetalleProvision = 'Test';
        wrrapperItem04.IdDetalleEdoCta = 'Estado cuenta';
        wrrapperItem04.IdEstadoCuenta = 'EstadoCuenta';
        wrrapperItem04.serie  = 'Corolla';
        wrrapperItem04.codigoModelo = '5462';    
        wrrapperItem04.incentivoProvisionadoDealer = 12391;
        wrrapperItem04.incentivoSolicitadoDealer = 12391;
        wrrapperItem04.nombreProvision = 'Provision de prueba';
        wrrapperItem04.idProvision = 'AQDNJHED56474';
        wrrapperItem04.idFacturaVenta = 'FACTURA2010';
        wrrapperItem04.VINEntregado = true;
        wrrapperItem04.IdEstadoCuenta = estadoCuenta.id;
        wrrapperItem04.validarTransferencia = false;
        wrrapperItem04.comentarioFinanzasTMEX = 'Rechazado';
        lisEdoCta.add(wrrapperItem04);
        
        EstadoCuentaController.saveEdoCta(lisEdoCta,false,true);
        EstadoCuentaController.saveEdoCta(lisEdoCta,true,true);
        EstadoCuentaController.saveEdoCta(lisEdoCta,false,false);
        List<TAM_DetalleEstadoCuenta__c> listaSave = [Select id,TAM_Factura_Dealer__c,TAM_Estatus_Finanzas__c,TAM_EstadoCuenta__c From TAM_DetalleEstadoCuenta__c limit 10];
        
        //Se ejecuta el metodo actualizarFacturaCobroDealer
        EstadoCuentaController.actualizarFacturaCobroDealer(listaSave); 
        
    }
    
    //Picklist test
    @isTest static void testMethod9(){
        //Se ejecuta el metodo getPickListEstatusFinanzas
        EstadoCuentaController.getPickListEstatusFinanzas();
        
        //Se ejecuta el metodo getPickListEsatusReg
        EstadoCuentaController.getPickListEsatusReg();
        
    }
    
    //Picklist saveRecordVIN
    @isTest static void testMethod10(){
        TAM_EstadoCuenta__c estadoCuenta = [select id,TAM_NombreDealer__c,TAM_CodigoDealer__c from TAM_EstadoCuenta__c where name = 'JULIO-TEST'];
        id detalleEdoCta = [Select id from TAM_DetalleEstadoCuenta__c WHERE TAM_VIN__C =: '12345678901234567' and TAM_ApellidosPropietario__c = 'Figueroas' limit 1].id;
        Id Movimiento = [Select id from Movimiento__c where VIN__r.name = '12345678901234567' ].id;
        EstadoCuentaController.saveRecordVIN('Retail', 45000, detalleEdoCta, estadoCuenta, 'edoCta');
        EstadoCuentaController.saveRecordVIN('Bono', 45000, detalleEdoCta, estadoCuenta, 'edoCta');
        EstadoCuentaController.saveRecordVIN('VentaCorporativa', 45000, detalleEdoCta, estadoCuenta, 'edoCta');
        EstadoCuentaController.saveRecordVIN('Retail', 45000, Movimiento, estadoCuenta, 'dealerDaily');
    }
    
    //Ordenamiento de decimales
    @isTest static void testMethod11(){
        List<Decimal> listaDecimales = new list<Decimal>();
        listaDecimales.add(10500);
        listaDecimales.add(18500);
        listaDecimales.add(1500);
        
        //Se ejecuta el metodo orderListIncentivos
        EstadoCuentaController.orderListIncentivos(listaDecimales);
        
    }
}